/* Classic Ladder Project */
/* Copyright (C) 2001 Marc Le Douarain */
/* mavati@club-internet.fr */
/* http://www.multimania.com/mavati/classicladder */
/* February 2001 */
/* Last update : 30 April. 2001 */
/* ----------- */
/* Draw a rung */
/* ----------- */
/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

char * DisplayInfo(int Type, int Offset)
{
    static char Buffer[20];
    switch(Type)
    {
        case VAR_MEM_BIT:
            sprintf(Buffer,"B%d",Offset);
            break;
        case VAR_TIMER_DONE:
            sprintf(Buffer,"T%d,D",Offset);
            break;
        case VAR_TIMER_RUNNING:
            sprintf(Buffer,"T%d,R",Offset);
            break;
        case VAR_MONOSTABLE_RUNNING:
            sprintf(Buffer,"M%d,R",Offset);
            break;
        default:
            sprintf(Buffer,"???");
            break;
    }
    return Buffer;
}

void DrawElement(int x,int y,StrElement Element)
{
    char BufTxt[20];
    StrTimer * Timer;
    StrMonostable * Monostable;
    int WidDiv2 = BLOCK_WIDTH/2;
    int WidDiv3 = BLOCK_WIDTH/3;
    int WidDiv4 = BLOCK_WIDTH/4;
    int HeiDiv2 = BLOCK_HEIGHT/2;
    int HeiDiv3 = BLOCK_HEIGHT/3;
    int HeiDiv4 = BLOCK_HEIGHT/4;
    GdkGC * DynaGcOff;
    GdkGC * TheGc;

    GdkColor DynaGdkColor;
    GdkGCValues DynaGCValues;
    GdkGC * DynaGcOn;
    DynaGdkColor.pixel = 0xFF22FF;
    DynaGdkColor.red = 0;
    DynaGdkColor.green = 0;
    DynaGdkColor.blue = 0;
//    DynaGCValues.foreground = DynaGdkColor;
//    DynaGc = gtk_gc_get(16,NULL,&DynaGCValues,1);

DynaGcOn = gdk_gc_new(pixmap);
    gdk_gc_set_foreground(DynaGcOn,&DynaGdkColor);
    DynaGcOff = drawing_area->style->black_gc;
    /* State with color */
    TheGc = drawing_area->style->black_gc;
    if (Element.DynamicState)
        TheGc = DynaGcOn;
    /* Drawing - - */
    switch(Element.Type)
    {
        case ELE_INPUT:
        case ELE_INPUT_NOT:
        case ELE_RISING_INPUT:
        case ELE_FALLING_INPUT:
        case ELE_OUTPUT:
        case ELE_OUTPUT_NOT:
        case ELE_OUTPUT_SET:
        case ELE_OUTPUT_RESET:
        case ELE_OUTPUT_JUMP:
                gdk_draw_line(pixmap, TheGc,
                                x,y+HeiDiv2, x+WidDiv3,y+HeiDiv2);
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv3*2,y+HeiDiv2, x+BLOCK_WIDTH,y+HeiDiv2);
    }
    /* Drawing || or () or --- */
    switch(Element.Type)
    {
        case ELE_INPUT:
        case ELE_INPUT_NOT:
        case ELE_RISING_INPUT:
        case ELE_FALLING_INPUT:
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv3,y+HeiDiv4, x+WidDiv3,y+BLOCK_HEIGHT-HeiDiv4);
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv3*2,y+HeiDiv4, x+WidDiv3*2,y+BLOCK_HEIGHT-HeiDiv4);
                break;
        case ELE_CONNECTION:
                gdk_draw_line(pixmap, TheGc,
                                x,y+HeiDiv2, x+BLOCK_WIDTH,y+HeiDiv2);


/*                           gdk_draw_rectangle (pixmap,
                                               drawing_area->style->black_gc,
                                               TRUE,
                                               x, y,
                                               BLOCK_WIDTH,
                                               BLOCK_HEIGHT);*/
                break;
        case ELE_OUTPUT:
        case ELE_OUTPUT_NOT:
        case ELE_OUTPUT_SET:
        case ELE_OUTPUT_RESET:
        case ELE_OUTPUT_JUMP:
                gdk_draw_arc (pixmap, TheGc, FALSE,
                                x+WidDiv4, y+WidDiv4, WidDiv2, HeiDiv2, (90+20)*64, 150*64);
                gdk_draw_arc (pixmap, TheGc, FALSE,
                                x+WidDiv4, y+WidDiv4, WidDiv2, HeiDiv2, (270+20)*64, 150*64);
                gdk_draw_line(pixmap, drawing_area->style->white_gc,
                                x+WidDiv3-1,y+HeiDiv2, x+WidDiv3,y+HeiDiv2);
                gdk_draw_line(pixmap, drawing_area->style->white_gc,
                                x+WidDiv3*2,y+HeiDiv2, x+WidDiv3*2+3,y+HeiDiv2);
                           break;
    }
    /* Drawing / */
    switch(Element.Type)
    {
        case ELE_INPUT_NOT:
        case ELE_OUTPUT_NOT:
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv3,y+BLOCK_HEIGHT-HeiDiv4, x+WidDiv3*2,y+HeiDiv4);
    }
    /* Drawing ^ or \/*/
    switch(Element.Type)
    {
        case ELE_RISING_INPUT:
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv3,y+HeiDiv3*2, x+WidDiv4*2,y+HeiDiv3);
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv4*2,y+HeiDiv3, x+WidDiv3*2,y+HeiDiv3*2);
                break;
        case ELE_FALLING_INPUT:
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv3,y+HeiDiv3, x+WidDiv4*2,y+HeiDiv3*2);
                gdk_draw_line(pixmap, TheGc,
                                x+WidDiv4*2,y+HeiDiv3*2, x+WidDiv3*2,y+HeiDiv3);
                break;
    }
    /* Drawing 'S'et or 'R'eset or 'J'ump for outputs */
    switch(Element.Type)
    {
        case ELE_OUTPUT_SET:
            gdk_draw_text(pixmap, drawing_area->style->font, TheGc,
                        x+WidDiv3+2,y+HeiDiv3*2,"S",1);
            break;
        case ELE_OUTPUT_RESET:
            gdk_draw_text(pixmap, drawing_area->style->font, TheGc,
                        x+WidDiv3+2,y+HeiDiv3*2,"R",1);
            break;
        case ELE_OUTPUT_JUMP:
            gdk_draw_text(pixmap, drawing_area->style->font, TheGc,
                        x+WidDiv3+2,y+HeiDiv3*2,"J",1);
            break;
    }
    /* Drawing complex ones : Timer, Monostable */
    switch(Element.Type)
    {
        case ELE_TIMER:
            Timer = &TimerArray[Element.VarNum];
            /* the box */
            gdk_draw_rectangle(pixmap, drawing_area->style->white_gc, TRUE,
                                x+WidDiv3-BLOCK_WIDTH, y+HeiDiv3,
                                BLOCK_WIDTH+1*WidDiv3, BLOCK_HEIGHT+1*HeiDiv3);
            gdk_draw_rectangle(pixmap, DynaGcOff, FALSE,
                                x+WidDiv3-BLOCK_WIDTH, y+HeiDiv3,
                                BLOCK_WIDTH+1*WidDiv3, BLOCK_HEIGHT+1*HeiDiv3);
            /* input : enable */
            gdk_draw_line(pixmap, (Timer->InputEnable)?DynaGcOn:DynaGcOff,
                                x-BLOCK_WIDTH,y+HeiDiv2, x-BLOCK_WIDTH+WidDiv3,y+HeiDiv2);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x-BLOCK_WIDTH,y+HeiDiv2-1,"I",1);
            /* output : done */
            gdk_draw_line(pixmap, (Timer->OutputDone)?DynaGcOn:DynaGcOff,
                                x+WidDiv3*2,y+HeiDiv2, x+BLOCK_WIDTH,y+HeiDiv2);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+BLOCK_WIDTH-WidDiv4,y+HeiDiv2-1,"D",1);
            /* output : running */
            gdk_draw_line(pixmap, (Timer->OutputRunning)?DynaGcOn:DynaGcOff,
                                x+WidDiv3*2,y+HeiDiv2+BLOCK_HEIGHT, x+BLOCK_WIDTH,y+HeiDiv2+BLOCK_HEIGHT);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+BLOCK_WIDTH-WidDiv4,y+HeiDiv2-1+BLOCK_HEIGHT,"R",1);
            /* Timer Number */
            sprintf(BufTxt,"T%d",Element.VarNum);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+WidDiv2-BLOCK_WIDTH,y+HeiDiv4-2,BufTxt,strlen(BufTxt));
            /* Current Value */
            sprintf(BufTxt,Timer->DisplayFormat,(float)Timer->Value/(float)Timer->Base);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+WidDiv2-BLOCK_WIDTH,y+BLOCK_HEIGHT,BufTxt,strlen(BufTxt));
            break;
        case ELE_MONOSTABLE:
            Monostable = &MonostableArray[Element.VarNum];
            /* the box */
            gdk_draw_rectangle(pixmap, drawing_area->style->white_gc, TRUE,
                                x+WidDiv3-BLOCK_WIDTH, y+HeiDiv3,
                                BLOCK_WIDTH+1*WidDiv3, BLOCK_HEIGHT+1*HeiDiv3);
            gdk_draw_rectangle(pixmap, DynaGcOff, FALSE,
                                x+WidDiv3-BLOCK_WIDTH, y+HeiDiv3,
                                BLOCK_WIDTH+1*WidDiv3, BLOCK_HEIGHT+1*HeiDiv3);
            /* input */
            gdk_draw_line(pixmap, (Monostable->Input)?DynaGcOn:DynaGcOff,
                                x-BLOCK_WIDTH,y+HeiDiv2, x-BLOCK_WIDTH+WidDiv3,y+HeiDiv2);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x-BLOCK_WIDTH,y+HeiDiv2-1,"I^",2);
            /* output : running */
            gdk_draw_line(pixmap, (Monostable->OutputRunning)?DynaGcOn:DynaGcOff,
                                x+WidDiv3*2,y+HeiDiv2, x+BLOCK_WIDTH,y+HeiDiv2);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+BLOCK_WIDTH-WidDiv4,y+HeiDiv2-1,"R",1);
            /* Monostable Number */
            sprintf(BufTxt,"M%d",Element.VarNum);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+WidDiv2-BLOCK_WIDTH,y+HeiDiv4-2,BufTxt,strlen(BufTxt));
            /* Current Value */
            sprintf(BufTxt,Monostable->DisplayFormat,(float)Monostable->Value/(float)Monostable->Base);
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                        x+WidDiv2-BLOCK_WIDTH,y+BLOCK_HEIGHT,BufTxt,strlen(BufTxt));
            break;
    }
    /* Drawing Var */
    switch(Element.Type)
    {
        case ELE_INPUT:
        case ELE_INPUT_NOT:
        case ELE_RISING_INPUT:
        case ELE_FALLING_INPUT:
        case ELE_OUTPUT:
        case ELE_OUTPUT_NOT:
        case ELE_OUTPUT_SET:
        case ELE_OUTPUT_RESET:
            strcpy(BufTxt,DisplayInfo(Element.VarType,Element.VarNum));
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                            x+WidDiv4,y+HeiDiv4-2,BufTxt,strlen(BufTxt));
            break;
        case ELE_OUTPUT_JUMP:
            gdk_draw_text(pixmap, drawing_area->style->font, drawing_area->style->black_gc,
                            x+1,y+HeiDiv4-2,RungArray[Element.VarNum].Label,
                            strlen(RungArray[Element.VarNum].Label));
            break;
    }
    /* Drawing cnx with top */
    if (Element.ConnectedWithTop)
    {
        if (Element.DynamicInput)
            gdk_draw_line(pixmap, DynaGcOn,
                x,y+HeiDiv2, x,y-HeiDiv2);
        else
            gdk_draw_line(pixmap, drawing_area->style->black_gc,
                x,y+HeiDiv2, x,y-HeiDiv2);
    }
gdk_gc_unref(DynaGcOn);
}

void DrawBars()
{
    gdk_draw_rectangle(pixmap, drawing_area->style->black_gc, TRUE,
                                1, 1,
                                3, BLOCK_HEIGHT*RUNG_HEIGHT);
    gdk_draw_rectangle(pixmap, drawing_area->style->black_gc, TRUE,
                                BLOCK_WIDTH*RUNG_WIDTH+OFFSET_X, 1,
                                3, BLOCK_HEIGHT*RUNG_HEIGHT);
}

void DrawRung(StrRung * Rung,char CleanBefore)
{
    char x,y;
    GdkRectangle update_rect;
    if (CleanBefore)
    {
            gdk_draw_rectangle(pixmap, drawing_area->style->white_gc, TRUE,
                                0, 0, BLOCK_WIDTH*RUNG_WIDTH+50, BLOCK_HEIGHT*RUNG_HEIGHT+50);
    }
    DrawBars();
    for (y=0;y<RUNG_HEIGHT;y++)
    {
        for(x=0;x<RUNG_WIDTH;x++)
        {
            DrawElement(x*BLOCK_WIDTH+OFFSET_X,y*BLOCK_HEIGHT+OFFSET_Y,Rung->Element[x][y]);
        }
    }
    update_rect.x = 0;
    update_rect.y = 0;
    update_rect.width = 400;
    update_rect.height = 200;
    gtk_widget_draw (drawing_area, &update_rect);
}
